#pragma once
#include "rituals.hpp"
#include "config.hpp"
#include "dinkyecs.hpp"
#include <optional>
#include "components.hpp"

namespace combat {

  struct BattleAction {
    DinkyECS::Entity entity;
    ai::EntityAI &ai;
    components::Combat &combat;
  };

  struct BattleEngine {
    std::unordered_map<DinkyECS::Entity, BattleAction> combatants;
    std::vector<BattleAction> pending_actions;

    void add_enemy(BattleAction ba);
    bool plan();
    std::optional<BattleAction> next();
    void dump();
  };
}
